// ignore: one_member_abstracts

// ignore: one_member_abstracts
abstract class BindingsInterface<T> {
  T dependencies();
}

/// [Bindings] should be extended or implemented.
/// When using `JuneMaterialApp`, all `JunePage`s and navigation
/// methods (like June.to()) have a `binding` property that takes an
/// instance of Bindings to manage the
/// dependencies() (via June.put()) for the Route you are opening.
// ignore: one_member_abstracts
@Deprecated('Use Binding instead')
abstract class Bindings extends BindingsInterface<void> {
  @override
  void dependencies();
}

// /// Simplifies Bindings generation from a single callback.
// /// To avoid the creation of a custom Binding instance per route.
// ///
// /// Example:
// /// ```
// /// JunePage(
// ///   name: '/',
// ///   page: () => Home(),
// ///   // This might cause you an error.
// ///   // binding: BindingsBuilder(() => June.put(HomeController())),
// ///   binding: BindingsBuilder(() { June.put(HomeController(); })),
// ///   // Using .lazyPut() works fine.
// ///   // binding: BindingsBuilder(() => June.lazyPut(() => HomeController())),
// /// ),
// /// ```
// class BindingsBuilder<T> extends Bindings {
//   /// Register your dependencies in the [builder] callback.
//   final BindingBuilderCallback builder;

//   /// Shortcut to register 1 Controller with June.put(),
//   /// Prevents the issue of the fat arrow function with the constructor.
//   /// BindingsBuilder(() => June.put(HomeController())),
//   ///
//   /// Sample:
//   /// ```
//   /// JunePage(
//   ///   name: '/',
//   ///   page: () => Home(),
//   ///   binding: BindingsBuilder.put(() => HomeController()),
//   /// ),
//   /// ```
//   factory BindingsBuilder.put(InstanceBuilderCallback<T> builder,
//       {String? tag, bool permanent = false}) {
//     return BindingsBuilder(
//         () => June.put<T>(builder(), tag: tag, permanent: permanent));
//   }

//   /// WARNING: don't use `()=> June.put(Controller())`,
//   /// if only passing 1 callback use `BindingsBuilder.put(Controller())`
//   /// or `BindingsBuilder(()=> June.lazyPut(Controller()))`
//   BindingsBuilder(this.builder);

//   @override
//   void dependencies() {
//     builder();
//   }
// }

typedef BindingBuilderCallback = void Function();
